{ This procedure draws fills polygon with arbitrary size texture, }
{ i.e. texture may be of any size and texture does not need to be }
{ aligned. For this case SizeX field in texture record must have  }
{ texture horizontal size.                                        }
{                                                                 }
{ The texture inner loop looks like this:                         }
{        ͻ                           }
{         UPPER 16BIT         LOWER 16BIT                  lea edi,[edi+ecx] }
{͹         xor ecx,-1        }
{  REG     HI WORD      HI BYTE      LO BYTE             add eax,YFracStep }
{͹         inc ecx           }
{  EAX   Curr-Y frac      ---      TEXTURE DATA          sbb ebx,ebx       }
{͹    @@inner:               }
{  EBX                USED AS INDEX                        add edx,esp       }
{͹         mov al,[esi]      }
{  ECX                LOOP COUNTER                         adc esi,[steptable+4+ebx*4]}
{͹         add eax,YFracStep }
{  EDX   Curr-X frac      ---          ---               sbb ebx,ebx       }
{͹         mov [edi+ecx],al  }
{  ESP   X-frac step      ---          ---               inc ecx           }
{͹         jnz @@inner       }
{  ESI               Source pointer      ---                                 }
{͹                           }
{  EDI             Destination pointer                                       }
{͹                           }
{YFracStepY-frac step     ---          ---                                 }
{ͼ                           }

Function SAR(f:fixed;a:byte):fixed;assembler;
  asm
    mov eax,f
    mov cl,a
    sar eax,cl
  end;

Procedure RenderArbitraryTexture8(poly:TPolygonPtr; txt:TTexture; Num:byte; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

    prestep:fixed;

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      {divide xlen by ylen}
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrLeftX:=Poly^[vrtx1].x+mFixedMul(prestep,LeftStepX);

      CurrLeftTextX:=Poly^[vrtx1].u;
      CurrLeftTextY:=Poly^[vrtx1].v;
      LeftTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrLeftTextX,height);
      LeftTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrLeftTextY,height);
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      {divide xlen by ylen}

      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrRightX:=Poly^[vrtx1].x+mFixedMul(prestep,RightStepX);

      CurrRightTextX:=Poly^[vrtx1].u;
      CurrRightTextY:=Poly^[vrtx1].v;
      RightTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrRightTextX,height);
      RightTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrRightTextY,height);
  end;

var hsize:longint;
    temp:fixed;
    x:fixed;
    steptable:array[0..1] of fixed;
    YFracStep,XFracStep,TextureOffs:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hSize>0 then begin
      TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,CurrRightX-CurrLeftX);
      TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,CurrRightX-CurrLeftX);

--      Prestep:=mFixedRound(CurrLeftX)-CurrLeftX;
--      CurrTextX:=CurrLeftTextX+mFixedMul(Prestep,TextStepX);
--      CurrTextY:=CurrLeftTextY+mFixedMul(Prestep,TextStepY);

      CurrTextX:=CurrLeftTextX;
      CurrTextY:=CurrLeftTextY;
--      steptable[1]:=(TextStepX shr 16) + (TextStepY shr 16)*Txt.SizeX;
--      steptable[0]:=steptable[1] + Txt.SizeX;
      steptable[1]:=(TextStepX div 65536) + (TextStepY div 65536)*Txt.SizeX;
      steptable[0]:=steptable[1] + Txt.SizeX;


      TextureOffs:=mRound(CurrTextX)+mRound(CurrTextY)*Txt.SizeX;

      asm
         mov eax,CurrTextY
         shl eax,16

         mov edx,TextStepY
         shl edx,16
         mov YFracStep,edx

         mov edx,TextStepX
         shl edx,16
         mov XFracStep,edx

         mov ecx,hsize

         mov edi,dword ptr Where -- get destination pointer
         add edi,offs
         add edi,x

         mov esi,dword ptr Txt -- get pointer to texture
         add esi,TextureOffs

         mov edx,CurrTextX
         shl edx,16

         shr ecx,1
         jnc @@skipOne
         -- put alone pixel --
         add eax,YFracStep
         sbb ebx,ebx
         add edx,XFracStep
         mov al,[esi]
         adc esi,[steptable+4+ebx*4]
         add eax,YFracStep
         sbb ebx,ebx
         mov [edi],al
         dec ecx

@@skipOne:
         lea edi,[edi+ecx*2]
         xor ecx,-1
         inc ecx
@@inner:
         -- get first pixel --
         add edx,XFracStep
         mov al,[esi]
         adc esi,[steptable+4+ebx*4]
         add eax,YFracStep
         sbb ebx,ebx

         -- get second pixel --
         add edx,XFracStep
         mov ah,[esi]
         adc esi,[steptable+4+ebx*4]
         add eax,YFracStep
         sbb ebx,ebx

         -- put both pixels --
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner

      end;

   end;

   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      CurrLeftTextX+:=LeftTextStepX;
      CurrLeftTextY+:=LeftTextStepY;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      CurrRightTextX+:=RightTextStepX;
      CurrRightTextY+:=RightTextStepY;
   end;

until false;
end;

(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
